
package Allegro.Bitmaps.Direct_Access is

    -- The following procedures are not part of Allegro but are helper routines
    -- for providing direct access to memory bitmaps.
    --
    -- Warning:
    -- No checking is done for the type of bitmap- it MUST be a memory bitmap-
    -- and no bounds checking is done on the pixel coordinates. Be sure you
    -- know what you're doing!

    function Memory_Getpixel_15_or_16_bpp( bmp  : not null A_Bitmap;
                                           x, y : Natural ) return Color_Type;

    function Memory_Getpixel_32( bmp  : not null A_Bitmap;
                                 x, y : Natural ) return Color_Type;

    procedure Memory_Putpixel_15_or_16_bpp( bmp   : not null A_Bitmap;
                                            x, y  : Natural;
                                            color : Color_Type );

    procedure Memory_Putpixel_32( bmp   : not null A_Bitmap;
                                  x, y  : Natural;
                                  color : Color_Type );

private

    pragma Import( C, Memory_Getpixel_15_or_16_bpp, "memory_getpixel_15_or_16_bpp" );
    pragma Import( C, Memory_Getpixel_32,           "memory_getpixel_32" );
    pragma Import( C, Memory_Putpixel_15_or_16_bpp, "memory_putpixel_15_or_16_bpp" );
    pragma Import( C, Memory_Putpixel_32,           "memory_putpixel_32" );

end Allegro.Bitmaps.Direct_Access;
