
with Interfaces.C;                      use Interfaces.C;

package body Allegro.Text_IO is

    function Text_Length( f : not null A_Font; str : String ) return Natural is

        function C_Text_Length( f : A_Font; str : C.char_array ) return Integer;
        pragma Import( C, C_Text_Length, "text_length" );

    begin
        return C_Text_Length( f, To_C( str ) );
    end Text_Length;

    ----------------------------------------------------------------------------
    procedure Textout_Ex( bmp   : not null A_Bitmap;
                          f     : not null A_Font;
                          s     : String;
                          x, y  : Integer;
                          color : Color_Type;
                          bg    : Integer ) is

        procedure C_Textout_Ex( bmp   : A_Bitmap;
                                f     : A_Font;
                                s     : C.char_array;
                                x, y  : Integer;
                                color : Color_Type;
                                bg    : Integer );
        pragma Import( C, C_Textout_Ex, "textout_ex" );

    begin
        C_Textout_Ex( bmp, f, To_C( s ), x, y, color, bg );
    end Textout_Ex;

    ----------------------------------------------------------------------------

    procedure Textout_Centre_Ex( bmp   : not null A_Bitmap;
                                 f     : not null A_Font;
                                 s     : String;
                                 x, y  : Integer;
                                 color : Color_Type;
                                 bg    : Integer ) is

        procedure C_Textout_Centre_Ex( bmp   : A_Bitmap;
                                       f     : A_Font;
                                       s     : C.char_array;
                                       x, y  : Integer;
                                       color : Color_Type;
                                       bg    : Integer );
        pragma Import( C, C_Textout_Centre_Ex, "textout_centre_ex" );

    begin
        C_Textout_Centre_Ex( bmp, f, To_C( s ), x, y, color, bg );
    end Textout_Centre_Ex;

    ----------------------------------------------------------------------------

    procedure Textout_Justify_Ex( bmp    : not null A_Bitmap;
                                  f      : not null A_Font;
                                  s      : String;
                                  x1, x2 : Integer;
                                  y      : Integer;
                                  diff   : Integer;
                                  color  : Color_Type;
                                  bg     : Integer ) is

        procedure C_Textout_Justify_Ex( bmp    : A_Bitmap;
                                        f      : A_Font;
                                        s      : C.char_array;
                                        x1, x2 : Integer;
                                        y      : Integer;
                                        diff   : Integer;
                                        color  : Color_Type;
                                        bg     : Integer );
        pragma Import( C, C_Textout_Justify_Ex, "textout_justify_ex" );

    begin
        C_Textout_Justify_Ex( bmp, f, To_C( s ), x1, x2, y, diff, color, bg );
    end Textout_Justify_Ex;

    ----------------------------------------------------------------------------

    procedure Textout_Right_Ex( bmp   : not null A_Bitmap;
                                f     : not null A_Font;
                                s     : String;
                                x, y  : Integer;
                                color : Color_Type;
                                bg    : Integer ) is

        procedure C_Textout_Right_Ex( bmp   : A_Bitmap;
                                      f     : A_Font;
                                      s     : C.char_array;
                                      x, y  : Integer;
                                      color : Color_Type;
                                      bg    : Integer );
        pragma Import( C, C_Textout_Right_Ex, "textout_right_ex" );

    begin
        C_Textout_Right_Ex( bmp, f, To_C( s ), x, y, color, bg );
    end Textout_Right_Ex;

end Allegro.Text_IO;
