
with Applications;                      use Applications;
with Debugging;                         use Debugging;
with GNAT.OS_Lib;
with Objects;
with Project;

-- The Project package is not used here but it must be referenced to ensure its
-- compilation.
pragma Warnings( off, Project );

package body Engine is

    function Engine_Main( argc : Integer; argv : Address ) return Integer is
        pragma Unreferenced( argc, argv );
        stat : Integer := 0;
    begin
        Create_Application;
        Get_Application.Run( stat );
        Delete_Application;

        pragma Debug( Objects.Display_Instance_Counts );

        return stat;
    exception
        when e : others =>
            pragma Debug( Dbg( "Engine_Main Exception: ..." ) );
            pragma Debug( Dbg( e ) );
            GNAT.OS_Lib.OS_Exit( 1 );
    end Engine_Main;

end Engine;
