
with Entities.Players;                  use Entities.Players;
with Resources;                         use Resources;

package body Entities.Enemies is

    not overriding
    procedure Construct( this     : access Enemy;
                         width,
                         height   : Natural;
                         libName  : String;
                         iconName : String ) is
    begin
        Entity(this.all).Construct( width, height, libName );
        this.icon := this.lib.Get_Id( iconName );
        this.frame := this.icon;
        if this.icon = 0 then
            raise RESOURCE_ERROR with "Icon <" & iconName & "> not found in " &
                                      "tile library <" & libName & ">";
        end if;
    end Construct;

    ----------------------------------------------------------------------------

    not overriding
    procedure Die( this : access Enemy ) is
        pragma Unreferenced( this );
    begin
        null;
    end Die;

    ----------------------------------------------------------------------------

    not overriding
    function Get_Icon( this : access Enemy ) return A_Bitmap is
    begin
        return this.lib.Get_Bitmap( this.icon );
    end Get_Icon;

    ----------------------------------------------------------------------------

    function Is_Shootable( this : not null access Enemy'Class ) return Boolean is
    begin
        return this.shootable;
    end Is_Shootable;

    ----------------------------------------------------------------------------

    overriding
    procedure Object_Read( stream : access Root_Stream_Type'Class; obj : out Enemy ) is
    begin
        Entity'Read( stream, Entity(obj) );
        obj.deadlyTouch := Boolean'Input( stream );
        obj.shootable := Boolean'Input( stream );
    end Object_Read;

    ----------------------------------------------------------------------------

    overriding
    procedure Object_Write( stream : access Root_Stream_Type'Class; obj : Enemy ) is
    begin
        Entity'Write( stream, Entity(obj) );
        Boolean'Output( stream, obj.deadlyTouch );
        Boolean'Output( stream, obj.shootable );
    end Object_Write;

    ----------------------------------------------------------------------------

    overriding
    procedure On_Collide( this : access Enemy; e : not null A_Entity ) is
    begin
        if e.all in Player'Class then
            if this.deadlyTouch and then not this.editingMode then
                A_Player(e).Die;
            end if;
        end if;
    end On_Collide;

    ----------------------------------------------------------------------------

    procedure Delete( this : in out A_Enemy ) is
    begin
        Delete( A_Object(this) );
    end Delete;

end Entities.Enemies;
