
with Ada.Strings.Hash;

package body Hashed_Strings is

    overriding
    function "="( l, r : Hashed_String ) return Boolean is
    begin
        return l.ht = r.ht;
    end "=";
    pragma Inline( "=" );

    ----------------------------------------------------------------------------

    function "<"( l, r : Hashed_String ) return Boolean is
    begin
        return l.ht < r.ht;
    end "<";
    pragma Inline( "<" );

    ----------------------------------------------------------------------------

    function "&"( l : Hashed_String; r : String ) return String is
    begin
        return To_String( l ) & r;
    end "&";
    pragma Inline( "&" );

    ----------------------------------------------------------------------------

    function "&"( l : String; r : Hashed_String ) return String is
    begin
        return l & To_String( r );
    end "&";
    pragma Inline( "&" );

    ----------------------------------------------------------------------------

    function "&"( l, r : Hashed_String ) return String is
    begin
        return To_String( l ) & To_String( r );
    end "&";
    pragma Inline( "&" );

    ----------------------------------------------------------------------------

    function Equivalent( l, r : Hashed_String ) return Boolean is
    begin
        return l.ht = r.ht and then l.str = r.str;
    end Equivalent;
    pragma Inline( Equivalent );

    ----------------------------------------------------------------------------

    function To_Hashed_String( str : String ) return Hashed_String is
        hs : Hashed_String;
    begin
        hs.ht := Ada.Strings.Hash( str );
        hs.str := To_Unbounded_String( str );
        return hs;
    end To_Hashed_String;

    ----------------------------------------------------------------------------

    function To_String( hs : Hashed_String ) return String is
    begin
        return To_String( hs.str );
    end To_String;
    pragma Inline( To_String );

end Hashed_Strings;
