
private package Tiles.Libraries.Loading is

    -- Initializes the package. Call this before calling Load_From_Disk.
    procedure Initialize;

    -- Finalizes the package. This should be called before Allegro is shutdown.
    -- No more assets can be loaded after finalization.
    procedure Finalize;

    -- Loads a library by name from disk. The library returned will continue to
    -- load asynchronously so not all bitmaps will be available immediately upon
    -- return. However, all the tile and matrices information will be available.
    -- If an error occurs then null will be returned.
    function Load_From_Disk( name : String ) return A_Tile_Library;
    pragma Precondition( name'Length >  0 );

end Tiles.Libraries.Loading;
