
with Ada.Characters.Handling;           use Ada.Characters.Handling;
with Ada.Strings.Fixed;                 use Ada.Strings.Fixed;
--with Debugging;                         use Debugging;

package body Widgets.Input_Boxes.Constraints is

    function Basename_Only( curstr, newstr : String ) return String is
        illegal : constant String := ":*?""/\<>|#.";
    begin
        for c in reverse newstr'Range loop
            if Index( illegal, String'(1=>newstr(c)) ) >= illegal'First then
                return curstr;
            end if;
        end loop;
        return newstr;
    end Basename_Only;

    ----------------------------------------------------------------------------

    function Filename_Only( curstr, newstr : String ) return String is
        illegal : constant String := ":*?""/\<>|#";
    begin
        for c in reverse newstr'Range loop
            if Index( illegal, String'(1=>newstr(c)) ) >= illegal'First then
                return curstr;
            end if;
        end loop;
        return newstr;
    end Filename_Only;

    ----------------------------------------------------------------------------

    function Int_Only( curstr, newstr : String ) return String is
    begin
        for c in reverse newstr'Range loop
            if not Is_Digit( newstr(c) ) then
                return curstr;
            end if;
        end loop;
        return newstr;
    end Int_Only;

end Widgets.Input_Boxes.Constraints;
