
with Actions;                           use Actions;
--with Debugging;                         use Debugging;
with Themes;                            use Themes;
with Themes.Palette;                    use Themes.Palette;
with Widgets.Buttons.Checkboxes;        use Widgets.Buttons.Checkboxes;
with Widgets.Buttons.Pushes;            use Widgets.Buttons.Pushes;
with Widgets.Buttons.Toggles;           use Widgets.Buttons.Toggles;
with Widgets.Containers.Panels;         use Widgets.Containers.Panels;
with Widgets.Input_Boxes;               use Widgets.Input_Boxes;
with Widgets.Labels;                    use Widgets.Labels;

package body Game_Views.Ked.Toolbar.Test_Panel is

    procedure Make_Test_Panel( view : not null A_Ked_View;
                               win  : not null A_Window ) is
        panel  : A_Panel;
        panel2 : A_Panel;
        label  : A_Label;
        button : A_Button;
        input  : A_Input_Box;
        check  : A_Checkbox;
    begin
        button := Create_Toggle_Button( view, "btnTestOpener", "Widget Test" );
        button.Set_Layout_LTRB( -119, -19, 20, 0 );
        button.Set_Focusable( False );
        button.Add_Listener( Action_Show_Test'Access );
        win.Add( A_Widget(button) );

        panel := Create_Panel( view, "pnlTest" );
        panel.Set_Layout_Center( 550, 400 );
        panel.Set_Visible( False );
        panel.Set_Zoom( 2.0 );
        panel.Set_Title( "Test Widgets" );

            panel2 := Create_Panel( view, "pnlTest2", "Titled" );
            panel2.Set_Layout_LTRB( 5, 5, -105, -95 );

                label := Create_Label( view, "lblTest1", "Left" );
                label.Set_Layout_LTWH( 5, 5, 60, 15 );
                label.Set_Border( Border_Line );
                panel2.Add( A_Widget(label) );

                label := Create_Label( view, "lblTest2", "Right" );
                label.Set_Layout_LTRB( 25, 25, 5, -40 );
                label.Set_Border( Border_Sunk );
                label.Set_Align( Align_Right );
                panel2.Add( A_Widget(label) );

                label := Create_Label( view, "lblTest3", "Center" );
                label.Set_Layout_LTRB( 5, -20, 5, 5 );
                label.Set_Border( Border_Raised );
                label.Set_Align( Align_Center );
                label.Set_Color( Text, base_colors(Chameleon3) );
                panel2.Add( A_Widget(label) );

            panel.Add( A_Widget(panel2) );

            panel2 := Create_Panel( view, "pnlTest3" );
            panel2.Set_Layout_LTRB( 110, 5, -210, -95 );
            panel2.Set_Border( Border_Sunk );

                button := Create_Push_Button( view, "btnTest1", "Push", "pointer_icon" );
                button.Set_Layout_CenterH( 75, 5, -25 );
                button.Set_Color( Foreground, base_colors(Plum1) );
                button.Set_Color( Background, base_colors(Plum3) );
                panel2.Add( A_Widget(button) );

                button := Create_Toggle_Button( view, "btnTest2", "Toggle" );
                button.Set_Layout_LTRB( 5, 30, 5, -45 );
                button.Set_Align( Align_Center );
                panel2.Add( A_Widget(button) );

                button := Create_Push_Button( view, "btnPopupTest", "Popup" );
                button.Set_Layout_CenterH( 75, 50, -65 );
                panel2.Add( A_Widget(button) );

            panel.Add( A_Widget(panel2) );

            panel2 := Create_Panel( view, "pnlTest4" );
            panel2.Set_Layout_LTWH( 215, 5, 150, 90 );
            panel2.Set_Border( Border_Line );

                input := Create_Input_Box( view, "ibTest1" );
                input.Set_Layout_LTRB( 5, 5, 5, -20 );
                input.Set_Text( "Enter text..." );
                input.Set_Color( Text, base_colors(Scarlet2) );
                panel2.Add( A_Widget(input) );

                check := Create_Checkbox( view, "chkTest1", "Checkbox", "switch_icon" );
                check.Set_Layout_LTRB( 5, 25, 5, -40 );
                check.Set_Border( Border_Line );
                panel2.Add( A_Widget(check) );

                check := Create_Checkbox( view, "chkTest2", "Checkbox2" );
                check.Set_Layout_LTRB( 5, 45, 5, -60 );
                panel2.Add( A_Widget(check) );

            panel.Add( A_Widget(panel2) );

            button := Create_Toggle_Button( view, "btnTest3", "Zoomed" );
            button.Set_Layout_LTWH( 370, 5, 77, 20 );
            button.Set_Zoom( 2.0 );
            button.Set_Color( Foreground, base_colors(Scarlet2) );
            button.Set_Color( Background, base_colors(Scarlet3) );
            panel.Add( A_Widget(button) );

        win.Add( A_Widget(panel) );
    end Make_Test_Panel;

    ----------------------------------------------------------------------------

    procedure Action_Show_Test( action : A_Button_Action ) is
    begin
        if action.Get_Id = Press then
            action.Get_Source.Get_View.Get_Widget( "pnlTest" ).Set_Visible( True );
        elsif action.Get_Id = Release then
            action.Get_Source.Get_View.Get_Widget( "pnlTest" ).Set_Visible( False );
        end if;
    end Action_Show_Test;

end Game_Views.Ked.Toolbar.Test_Panel;
