
with Events.Listeners;                  use Events.Listeners;

private with Ada.Containers.Indefinite_Vectors;
private with Events;

package Widgets.Palettes.Items is

    function Create_Item_Palette( view : not null access Game_Views.Game_View'Class;
                                  id   : String ) return A_Palette;
    pragma Precondition( id'Length > 0 );
    pragma Postcondition( Create_Item_Palette'Result /= null );

private

    use Events;

    package Item_Types is new Ada.Containers.Indefinite_Vectors( Positive, String, "=" );

    type Item_Palette is new Palette and Event_Listener with
        record
            itemTypes : Item_Types.Vector;  -- vector of item ids
        end record;

    procedure Construct( this : access Item_Palette;
                         view : not null access Game_Views.Game_View'Class;
                         id   : String );
    pragma Precondition( id'Length > 0 );

    procedure Delete( this : in out Item_Palette );

    procedure Get_Item_Details( this   : access Item_Palette;
                                row,
                                col    : Natural;
                                bmp    : out A_Bitmap;
                                border : out Color_Type );

    function Get_Scroll_Inc_Y( this : access Item_Palette ) return Integer;

    function Get_Item_Count( this : access Item_Palette ) return Natural;

    procedure Handle_Event( this : access Item_Palette;
                            evt  : in out A_Event;
                            resp : out Response_Type );
    pragma Precondition( evt /= null );

    procedure Handle_Mouse_Press( this : access Item_Palette;
                                  evt  : not null A_Mouse_Button_Event );

end Widgets.Palettes.Items;
